<template lang="pug">
.container-fluid.h-100
  AnimBlock(:appear='true')
    h1.mt-1.text-center(ref="title") {{ namespace }}
      small.text-muted  Gitlab projects

  .row
    .col-12
      h5.text-muted.mr-2 Groups
        select.ml-2.d-inline.w-auto.form-select.form-select-sm(aria-label="group" v-model='selectedNamespace')
          option(selected='selected' :value='namespace') {{ namespace }}
          option(v-for='group in groups' :value='group.full_path') {{ group.full_path }}

  .row
    .col-12
      table.table.flex-grow-1
        AnimGroup.flex-grow-1(tag='tbody')
          Project(v-for="project in projects" :key="project.id" :project='project' :id="project.id" :name="project.name_with_namespace")
  .row.text-center(v-if="loading" key="spin")
    .col.text-center
      .fa.fa-spinner.fa-pulse
</template>

<script>
import axios from 'axios'
import _ from 'lodash'
import Project from './Project.vue'
import { currentUrl, fetchAllPages } from './utilities'

import AnimBlock from './BaseAnimationBlock.vue'
import AnimGroup from './BaseAnimationGroup.vue'

export default {
  components: { Project, AnimBlock, AnimGroup },
  props: {
    namespace: { default: null },
    recursive: { default: true }
  },
  data() {
    return { projects: null, groups: null, loading: true, _task: null, selectedNamespace: null };
  },
  watch: {
    namespace() {
      this.selectedNamespace = this.namespace;
      this.update();
    },
    recursive() {
      this.update();
    },
    selectedNamespace(namespace) {
      if (namespace !== this.namespace) {
        this.$router.push({ query: { namespace } });
      }
    }
  },
  async mounted() {
    this.selectedNamespace = this.namespace;

    await this.resetNamespace();

    await this.update();
  },
  methods: {
    async resetNamespace() {
      if (_.isNil(this.namespace)) {
        const response = await axios.get(currentUrl() + '/namespace')
        
        this.selectedNamespace = response.data;
      }
    },
    async loadProjects(path, opts) {
      // Load every project stored directly in the namespace
      await fetchAllPages(currentUrl() + '/projects', { namespace: path }, opts, async (response) => {
        this.projects = _.orderBy(_.concat(this.projects || [], response), ['name_with_namespace', 'id']);
      })
    },
    async loadGroup(path, opts) {
      // Load the current group project
      await this.loadProjects(path, opts)

      // Then load it's sub groups
      await fetchAllPages(currentUrl() + '/groups', { namespace: path }, opts, async (response) => {
        this.groups = _.orderBy(_.concat(this.groups || [], response), ['full_path', 'id']);
        
        // Recursively call the request for all the sub-groups
        await Promise.all(_.map(response, (group) =>
          this.loadGroup(group.full_path, opts))
        );

      })
    },
    async update() {
      if (!this.namespace) { return; }

      this.loading = true;

      // reset projects and groups buffers
      this.projects = null;
      this.groups = null;

      // abort prevous task if still running
      if (this._task) {
        this._task.aborted = true;
      }

      var task = this._task = {};

      if (this.recursive) {
        await this.loadGroup(this.namespace, task); // Load projects in group recursively
      } else {
        await this.loadProjects(this.namespace, task); // Only load projects in the current dir
      }

      this.loading = false;
    }
  }
}
</script>

<style>
</style>
